#include "acdptu.h"

#include "dptu_c_types.h"
#include "dptu_driver.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* --- Attribute set_savefile ------------------------------------------- */

/** Validation codel set_logfile of attribute set_savefile.
 *
 * Returns genom_ok.
 * Throws dptu_e_file.
 */
genom_event
set_logfile(const char save_file[256], genom_context self)
{
  /* skeleton sample: insert your code */
  /* skeleton sample */ return genom_ok;
}

/* --- Function close --------------------------------------------------- */

/** Codel dptu_close of function close.
 *
 * Returns genom_ok.
 * Throws dptu_e_ptu.
 */
genom_event
dptu_close(dptu_ids *ids, genom_context self)
{
  dptu_t *p = (dptu_t *)ids->ptu;
  dptu_e_ptu_detail d;

  if (p == NULL) {
    strcpy(d.what, "PTU driver not initialised");
    return dptu_e_ptu(&d, self);
  }

  if (ptuClose(p) < 0) {
    strcpy(d.what, "unable to close ptu file descriptor");
    return dptu_e_ptu(&d, self);
  }

  ids->ptu = NULL;
  free(p);

  /* skeleton sample */ return genom_ok;
}

/* --- Function stop_monitor_position ----------------------------------- */

/** Codel dptu_stop_monitor_position of function stop_monitor_position.
 *
 * Returns genom_ok.
 * Throws dptu_e_ptu.
 */
genom_event
dptu_stop_monitor_position(bool *monitor, genom_context self)
{
  *monitor = false;
  /* skeleton sample */ return genom_ok;
}
